using Supabase.Postgrest.Responses;
using static Supabase.Postgrest.Constants;
using Supabase;
using UnitTestTripHelper.Model;
using UnitTestTripHelper.SupabaseConnect;

namespace UnitTestTripHelper
{
    public class UnitTest1
    {
        [Fact] //    
        public async void TestCreateUser()
        {
            Client new_user = await Connect.Domain();
            Assert.NotNull(new_user);
        }
        [Fact] //   
        public async void TestLoginUser()
        {
            Client new_user = await Connect.Domain();
            string email = "r@r.com";
            string password = "r";
            var user = await new_user.Auth.SignIn(email, password);
            Assert.NotNull(new_user);
        }
        [Fact] //    
        public async void TestSignUpNewUser()
        {
            Client new_user = await Connect.Domain();
            string email = "mikamakiboom7@gmail.com";
            string password = "test111";
            var user = await new_user.Auth.SignUp(email, password);
            await new_user.Auth.SignOut();
            Assert.NotNull(new_user);
        }
        [Fact] //     
        public async void TestReadDataCity()
        {
            Client conect = await Connect.Domain();
            int count = 0;
            int except = 49;
            count = await conect.From<City>().Count(CountType.Exact);
            Assert.True(count == except);
        }
        [Fact] //      
        public async void TestInsertDataCountry()
        {
            Client conect = await Connect.Domain();
            bool check = false;
            Country model = new Country
            {
                Title = " ",
                Flag = null
            };
            try
            {
                ModeledResponse<Country> response = await conect.From<Country>().Insert(model);
                check = true;
            }
            catch
            {
                check = false;
            }
            Assert.True(check);
        }
        [Fact] //     
        public async void TestDeleteData()
        {
            Client conect = await Connect.Domain();
            bool check = false;
            
            try
            {
                await conect
                   .From<City>()
                   .Where(x => x.Id == 2)
                   .Delete();
                check = true;
            }
            catch
            {
                check = false;
            }
            Assert.True(check);
        }
        [Fact] //      ,    1  5  
        public async void TestCheckTriggerForRatingInHotels()
        {
            Client conect = await Connect.Domain();
            int rating = 6;
            bool check = false;
            try
            {
                var model = await conect
                    .From<Hotels>()
                    .Where(x => x.Id == 1)
                    .Set(x => x.Rating, rating)
                    .Update();
                check = true;
            }
            catch
            {
                check = false;
            }
            Assert.False(check);
        }
        [Fact] //         
        public async void TestCheckTriggerForQuantityInHotels()
        {
            Client conect = await Connect.Domain();
            int quantity = -10;
            bool check = false;
            try
            {
                var model = await conect
                    .From<Hotels>()
                    .Where(x => x.Id == 3)
                    .Set(x => x.Quantity_of_rooms, quantity)
                    .Update();
                check = true;
            }
            catch
            {
                check = false;
            }
            Assert.False(check);
        }
        [Fact] //         
        public async void TestCheckTriggerForFloorsInHotels()
        {
            Client conect = await Connect.Domain();
            int floors = -100;
            bool check = false;
            try
            {
                var model = await conect
                    .From<Hotels>()
                    .Where(x => x.Id == 3)
                    .Set(x => x.Floors, floors)
                    .Update();
                check = true;
            }
            catch
            {
                check = false;
            }
            Assert.False(check);
        }
        [Fact] //         
        public async void TestCheckTriggerForAverageCheckInRestaurants()
        {
            Client conect = await Connect.Domain();
            int average = -15;
            bool check = false;
            try
            {
                var model = await conect
                    .From<Restaurants>()
                    .Where(x => x.Id == 3)
                    .Set(x => x.Average_check, average)
                    .Update();
                check = true;
            }
            catch
            {
                check = false;
            }
            Assert.False(check);
        }
        [Fact] //         
        public async void TestCheckTriggerForPriceInAttractions()
        {
            Client conect = await Connect.Domain();
            int price = -3;
            bool check = false;
            try
            {
                var model = await conect
                    .From<Attractions>()
                    .Where(x => x.Id == 3)
                    .Set(x => x.Price_showing, price)
                    .Update();
                check = true;
            }
            catch
            {
                check = false;
            }
            Assert.False(check);
        }
        [Fact] //     varchar  
        public async void TestCheckSizeVarcharTitle()
        {
            Client conect = await Connect.Domain();
            bool check = false;
            string title = "Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut "; //203 
            try
            {
               var model = await conect
                    .From<Attractions>()
                    .Where (x => x.Id == 1)
                    .Set(x=> x.Name, title)
                    .Update();
                check = true;
            }
            catch
            {
                check = false;
            }
            Assert.False(check);
        }
    }
}